# Class VulkanGraphicsPipelineCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanGraphicsPipelineCreateInfo

All Implemented Interfaces:
  `VulkanGraphicsPipelineCreateInfoType`

public final class VulkanGraphicsPipelineCreateInfo extends Object implements VulkanGraphicsPipelineCreateInfoType
Structure specifying parameters of a newly created graphics pipeline.

See Also:
  - "VkGraphicsPipelineCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanGraphicsPipelineCreateInfo.Builder`
  Builds instances of type `VulkanGraphicsPipelineCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Optional<VulkanPipelineType>`
  `basePipeline()`
  `OptionalInt`
  `basePipelineIndex()`
  `static VulkanGraphicsPipelineCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanGraphicsPipelineCreateInfo`.
  `Optional<VulkanPipelineColorBlendStateCreateInfo>`
  `colorBlendState()`
  `static VulkanGraphicsPipelineCreateInfo`
  `copyOf(VulkanGraphicsPipelineCreateInfoType instance)`
  Creates an immutable copy of a `VulkanGraphicsPipelineCreateInfoType` value.
  `Optional<VulkanPipelineDepthStencilStateCreateInfo>`
  `depthStencilState()`
  `Optional<VulkanPipelineDynamicStateCreateInfo>`
  `dynamicState()`
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanGraphicsPipelineCreateInfo` that have equal attribute values.
  `Set<VulkanPipelineCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `stages`, `vertexInputState`, `inputAssemblyState`, `tessellationState`, `viewportState`, `rasterizationState`, `multisampleState`, `depthStencilState`, `colorBlendState`, `dynamicState`, `layout`, `renderPass`, `subpass`, `basePipeline`, `basePipelineIndex`, `renderingCreateInfo`.
  `VulkanPipelineInputAssemblyStateCreateInfo`
  `inputAssemblyState()`
  `VulkanPipelineLayoutType`
  `layout()`
  `Optional<VulkanPipelineMultisampleStateCreateInfo>`
  `multisampleState()`
  `VulkanPipelineRasterizationStateCreateInfo`
  `rasterizationState()`
  `Optional<VulkanPipelineRenderingCreateInfo>`
  `renderingCreateInfo()`
  `Optional<VulkanRenderPassType>`
  `renderPass()`
  `List<VulkanPipelineShaderStageCreateInfo>`
  `stages()`
  `int`
  `subpass()`
  `Optional<VulkanPipelineTessellationStateCreateInfo>`
  `tessellationState()`
  `String`
  `toString()`
  Prints the immutable value `VulkanGraphicsPipelineCreateInfo` with attribute values.
  `VulkanPipelineVertexInputStateCreateInfo`
  `vertexInputState()`
  `Optional<VulkanPipelineViewportStateCreateInfo>`
  `viewportState()`
  `final VulkanGraphicsPipelineCreateInfo`
  `withBasePipeline(VulkanPipelineType value)`
  Copy the current immutable object by setting a present value for the optional `basePipeline` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withBasePipeline(Optional<? extends VulkanPipelineType> optional)`
  Copy the current immutable object by setting an optional value for the `basePipeline` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withBasePipelineIndex(int value)`
  Copy the current immutable object by setting a present value for the optional `basePipelineIndex` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withBasePipelineIndex(OptionalInt optional)`
  Copy the current immutable object by setting an optional value for the `basePipelineIndex` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withColorBlendState(VulkanPipelineColorBlendStateCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `colorBlendState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withColorBlendState(Optional<? extends VulkanPipelineColorBlendStateCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `colorBlendState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withDepthStencilState(VulkanPipelineDepthStencilStateCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `depthStencilState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withDepthStencilState(Optional<? extends VulkanPipelineDepthStencilStateCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `depthStencilState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withDynamicState(VulkanPipelineDynamicStateCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `dynamicState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withDynamicState(Optional<? extends VulkanPipelineDynamicStateCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `dynamicState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withFlags(VulkanPipelineCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanGraphicsPipelineCreateInfo`
  `withFlags(Iterable<VulkanPipelineCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanGraphicsPipelineCreateInfo`
  `withInputAssemblyState(VulkanPipelineInputAssemblyStateCreateInfo value)`
  Copy the current immutable object by setting a value for the `inputAssemblyState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withLayout(VulkanPipelineLayoutType value)`
  Copy the current immutable object by setting a value for the `layout` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withMultisampleState(VulkanPipelineMultisampleStateCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `multisampleState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withMultisampleState(Optional<? extends VulkanPipelineMultisampleStateCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `multisampleState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withRasterizationState(VulkanPipelineRasterizationStateCreateInfo value)`
  Copy the current immutable object by setting a value for the `rasterizationState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withRenderingCreateInfo(VulkanPipelineRenderingCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `renderingCreateInfo` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withRenderingCreateInfo(Optional<? extends VulkanPipelineRenderingCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `renderingCreateInfo` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withRenderPass(VulkanRenderPassType value)`
  Copy the current immutable object by setting a present value for the optional `renderPass` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withRenderPass(Optional<? extends VulkanRenderPassType> optional)`
  Copy the current immutable object by setting an optional value for the `renderPass` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withStages(VulkanPipelineShaderStageCreateInfo... elements)`
  Copy the current immutable object with elements that replace the content of `stages`.
  `final VulkanGraphicsPipelineCreateInfo`
  `withStages(Iterable<? extends VulkanPipelineShaderStageCreateInfo> elements)`
  Copy the current immutable object with elements that replace the content of `stages`.
  `final VulkanGraphicsPipelineCreateInfo`
  `withSubpass(int value)`
  Copy the current immutable object by setting a value for the `subpass` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withTessellationState(VulkanPipelineTessellationStateCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `tessellationState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withTessellationState(Optional<? extends VulkanPipelineTessellationStateCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `tessellationState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withVertexInputState(VulkanPipelineVertexInputStateCreateInfo value)`
  Copy the current immutable object by setting a value for the `vertexInputState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withViewportState(VulkanPipelineViewportStateCreateInfo value)`
  Copy the current immutable object by setting a present value for the optional `viewportState` attribute.
  `final VulkanGraphicsPipelineCreateInfo`
  `withViewportState(Optional<? extends VulkanPipelineViewportStateCreateInfo> optional)`
  Copy the current immutable object by setting an optional value for the `viewportState` attribute.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanPipelineCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      Flags specifying how the pipeline will be generated.

  - ### stages

    public List<VulkanPipelineShaderStageCreateInfo> stages()
    Specified by:
      `stages` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      The shader stages to be included in the graphics pipeline.

  - ### vertexInputState

    public VulkanPipelineVertexInputStateCreateInfo vertexInputState()
    Specified by:
      `vertexInputState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the vertex shading stage

  - ### inputAssemblyState

    public VulkanPipelineInputAssemblyStateCreateInfo inputAssemblyState()
    Specified by:
      `inputAssemblyState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the input assembly stage

  - ### tessellationState

    public Optional<VulkanPipelineTessellationStateCreateInfo> tessellationState()
    Specified by:
      `tessellationState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the tesselation stage

  - ### viewportState

    public Optional<VulkanPipelineViewportStateCreateInfo> viewportState()
    Specified by:
      `viewportState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the viewport

  - ### rasterizationState

    public VulkanPipelineRasterizationStateCreateInfo rasterizationState()
    Specified by:
      `rasterizationState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the rasterization stage

  - ### multisampleState

    public Optional<VulkanPipelineMultisampleStateCreateInfo> multisampleState()
    Specified by:
      `multisampleState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for multisampling

  - ### depthStencilState

    public Optional<VulkanPipelineDepthStencilStateCreateInfo> depthStencilState()
    Specified by:
      `depthStencilState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the depth/stencil buffer

  - ### colorBlendState

    public Optional<VulkanPipelineColorBlendStateCreateInfo> colorBlendState()
    Specified by:
      `colorBlendState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      State for the color blending stage

  - ### dynamicState

    public Optional<VulkanPipelineDynamicStateCreateInfo> dynamicState()
    Specified by:
      `dynamicState` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      Dynamic state

  - ### layout

    public VulkanPipelineLayoutType layout()
    Specified by:
      `layout` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      The description of binding locations used by both the pipeline and descriptor sets used with the pipeline.

  - ### renderPass

    public Optional<VulkanRenderPassType> renderPass()
    Specified by:
      `renderPass` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      A handle to a render pass object describing the environment in which the pipeline will be used; the pipeline must only be used with an instance of any render pass compatible with the one provided.

  - ### subpass

    public int subpass()
    Specified by:
      `subpass` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      The index of the subpass in the render pass where this pipeline will be used.

  - ### basePipeline

    public Optional<VulkanPipelineType> basePipeline()
    Specified by:
      `basePipeline` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      A pipeline to derive from.

  - ### basePipelineIndex

    public OptionalInt basePipelineIndex()
    Specified by:
      `basePipelineIndex` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      An index into the createInfos parameter to use as a pipeline to derive from.

  - ### renderingCreateInfo

    public Optional<VulkanPipelineRenderingCreateInfo> renderingCreateInfo()
    Specified by:
      `renderingCreateInfo` in interface `VulkanGraphicsPipelineCreateInfoType`
    Returns:
      The rendering info used for dynamic rendering

  - ### withFlags

    public final VulkanGraphicsPipelineCreateInfo withFlags(VulkanPipelineCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanGraphicsPipelineCreateInfo withFlags(Iterable<VulkanPipelineCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withStages

    public final VulkanGraphicsPipelineCreateInfo withStages(VulkanPipelineShaderStageCreateInfo... elements)
    Copy the current immutable object with elements that replace the content of `stages`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withStages

    public final VulkanGraphicsPipelineCreateInfo withStages(Iterable<? extends VulkanPipelineShaderStageCreateInfo> elements)
    Copy the current immutable object with elements that replace the content of `stages`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of stages elements to set
    Returns:
      A modified copy or `this` if not changed

  - ### withVertexInputState

    public final VulkanGraphicsPipelineCreateInfo withVertexInputState(VulkanPipelineVertexInputStateCreateInfo value)
    Copy the current immutable object by setting a value for the `vertexInputState` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for vertexInputState
    Returns:
      A modified copy or the `this` object

  - ### withInputAssemblyState

    public final VulkanGraphicsPipelineCreateInfo withInputAssemblyState(VulkanPipelineInputAssemblyStateCreateInfo value)
    Copy the current immutable object by setting a value for the `inputAssemblyState` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for inputAssemblyState
    Returns:
      A modified copy or the `this` object

  - ### withTessellationState

    public final VulkanGraphicsPipelineCreateInfo withTessellationState(VulkanPipelineTessellationStateCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `tessellationState` attribute.
    Parameters:
      `value` - The value for tessellationState
    Returns:
      A modified copy or `this` if not changed

  - ### withTessellationState

    public final VulkanGraphicsPipelineCreateInfo withTessellationState(Optional<? extends VulkanPipelineTessellationStateCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `tessellationState` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for tessellationState
    Returns:
      A modified copy or `this` if not changed

  - ### withViewportState

    public final VulkanGraphicsPipelineCreateInfo withViewportState(VulkanPipelineViewportStateCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `viewportState` attribute.
    Parameters:
      `value` - The value for viewportState
    Returns:
      A modified copy or `this` if not changed

  - ### withViewportState

    public final VulkanGraphicsPipelineCreateInfo withViewportState(Optional<? extends VulkanPipelineViewportStateCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `viewportState` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for viewportState
    Returns:
      A modified copy or `this` if not changed

  - ### withRasterizationState

    public final VulkanGraphicsPipelineCreateInfo withRasterizationState(VulkanPipelineRasterizationStateCreateInfo value)
    Copy the current immutable object by setting a value for the `rasterizationState` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for rasterizationState
    Returns:
      A modified copy or the `this` object

  - ### withMultisampleState

    public final VulkanGraphicsPipelineCreateInfo withMultisampleState(VulkanPipelineMultisampleStateCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `multisampleState` attribute.
    Parameters:
      `value` - The value for multisampleState
    Returns:
      A modified copy or `this` if not changed

  - ### withMultisampleState

    public final VulkanGraphicsPipelineCreateInfo withMultisampleState(Optional<? extends VulkanPipelineMultisampleStateCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `multisampleState` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for multisampleState
    Returns:
      A modified copy or `this` if not changed

  - ### withDepthStencilState

    public final VulkanGraphicsPipelineCreateInfo withDepthStencilState(VulkanPipelineDepthStencilStateCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `depthStencilState` attribute.
    Parameters:
      `value` - The value for depthStencilState
    Returns:
      A modified copy or `this` if not changed

  - ### withDepthStencilState

    public final VulkanGraphicsPipelineCreateInfo withDepthStencilState(Optional<? extends VulkanPipelineDepthStencilStateCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `depthStencilState` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for depthStencilState
    Returns:
      A modified copy or `this` if not changed

  - ### withColorBlendState

    public final VulkanGraphicsPipelineCreateInfo withColorBlendState(VulkanPipelineColorBlendStateCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `colorBlendState` attribute.
    Parameters:
      `value` - The value for colorBlendState
    Returns:
      A modified copy or `this` if not changed

  - ### withColorBlendState

    public final VulkanGraphicsPipelineCreateInfo withColorBlendState(Optional<? extends VulkanPipelineColorBlendStateCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `colorBlendState` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for colorBlendState
    Returns:
      A modified copy or `this` if not changed

  - ### withDynamicState

    public final VulkanGraphicsPipelineCreateInfo withDynamicState(VulkanPipelineDynamicStateCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `dynamicState` attribute.
    Parameters:
      `value` - The value for dynamicState
    Returns:
      A modified copy or `this` if not changed

  - ### withDynamicState

    public final VulkanGraphicsPipelineCreateInfo withDynamicState(Optional<? extends VulkanPipelineDynamicStateCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `dynamicState` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for dynamicState
    Returns:
      A modified copy or `this` if not changed

  - ### withLayout

    public final VulkanGraphicsPipelineCreateInfo withLayout(VulkanPipelineLayoutType value)
    Copy the current immutable object by setting a value for the `layout` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for layout
    Returns:
      A modified copy or the `this` object

  - ### withRenderPass

    public final VulkanGraphicsPipelineCreateInfo withRenderPass(VulkanRenderPassType value)
    Copy the current immutable object by setting a present value for the optional `renderPass` attribute.
    Parameters:
      `value` - The value for renderPass
    Returns:
      A modified copy or `this` if not changed

  - ### withRenderPass

    public final VulkanGraphicsPipelineCreateInfo withRenderPass(Optional<? extends VulkanRenderPassType> optional)
    Copy the current immutable object by setting an optional value for the `renderPass` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for renderPass
    Returns:
      A modified copy or `this` if not changed

  - ### withSubpass

    public final VulkanGraphicsPipelineCreateInfo withSubpass(int value)
    Copy the current immutable object by setting a value for the `subpass` attribute. A value equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for subpass
    Returns:
      A modified copy or the `this` object

  - ### withBasePipeline

    public final VulkanGraphicsPipelineCreateInfo withBasePipeline(VulkanPipelineType value)
    Copy the current immutable object by setting a present value for the optional `basePipeline` attribute.
    Parameters:
      `value` - The value for basePipeline
    Returns:
      A modified copy or `this` if not changed

  - ### withBasePipeline

    public final VulkanGraphicsPipelineCreateInfo withBasePipeline(Optional<? extends VulkanPipelineType> optional)
    Copy the current immutable object by setting an optional value for the `basePipeline` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for basePipeline
    Returns:
      A modified copy or `this` if not changed

  - ### withBasePipelineIndex

    public final VulkanGraphicsPipelineCreateInfo withBasePipelineIndex(int value)
    Copy the current immutable object by setting a present value for the optional `basePipelineIndex` attribute.
    Parameters:
      `value` - The value for basePipelineIndex
    Returns:
      A modified copy or `this` if not changed

  - ### withBasePipelineIndex

    public final VulkanGraphicsPipelineCreateInfo withBasePipelineIndex(OptionalInt optional)
    Copy the current immutable object by setting an optional value for the `basePipelineIndex` attribute. An equality check is used on inner value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for basePipelineIndex
    Returns:
      A modified copy or `this` if not changed

  - ### withRenderingCreateInfo

    public final VulkanGraphicsPipelineCreateInfo withRenderingCreateInfo(VulkanPipelineRenderingCreateInfo value)
    Copy the current immutable object by setting a present value for the optional `renderingCreateInfo` attribute.
    Parameters:
      `value` - The value for renderingCreateInfo
    Returns:
      A modified copy or `this` if not changed

  - ### withRenderingCreateInfo

    public final VulkanGraphicsPipelineCreateInfo withRenderingCreateInfo(Optional<? extends VulkanPipelineRenderingCreateInfo> optional)
    Copy the current immutable object by setting an optional value for the `renderingCreateInfo` attribute. A shallow reference equality check is used on unboxed optional value to prevent copying of the same value by returning `this`.
    Parameters:
      `optional` - An optional value for renderingCreateInfo
    Returns:
      A modified copy or `this` if not changed

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanGraphicsPipelineCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `stages`, `vertexInputState`, `inputAssemblyState`, `tessellationState`, `viewportState`, `rasterizationState`, `multisampleState`, `depthStencilState`, `colorBlendState`, `dynamicState`, `layout`, `renderPass`, `subpass`, `basePipeline`, `basePipelineIndex`, `renderingCreateInfo`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanGraphicsPipelineCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### copyOf

    public static VulkanGraphicsPipelineCreateInfo copyOf(VulkanGraphicsPipelineCreateInfoType instance)
    Creates an immutable copy of a `VulkanGraphicsPipelineCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanGraphicsPipelineCreateInfo instance

  - ### builder

    public static VulkanGraphicsPipelineCreateInfo.Builder builder()
    Creates a builder for `VulkanGraphicsPipelineCreateInfo`.

        VulkanGraphicsPipelineCreateInfo.builder()
           .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanPipelineCreateFlag) // flags elements
           .addStages|addAllStages(VulkanPipelineShaderStageCreateInfo) // stages elements
           .setVertexInputState(com.io7m.jcoronado.api.VulkanPipelineVertexInputStateCreateInfo) // required vertexInputState
           .setInputAssemblyState(com.io7m.jcoronado.api.VulkanPipelineInputAssemblyStateCreateInfo) // required inputAssemblyState
           .setTessellationState(Optional<VulkanPipelineTessellationStateCreateInfo>) // optional tessellationState
           .setViewportState(Optional<VulkanPipelineViewportStateCreateInfo>) // optional viewportState
           .setRasterizationState(com.io7m.jcoronado.api.VulkanPipelineRasterizationStateCreateInfo) // required rasterizationState
           .setMultisampleState(Optional<VulkanPipelineMultisampleStateCreateInfo>) // optional multisampleState
           .setDepthStencilState(Optional<VulkanPipelineDepthStencilStateCreateInfo>) // optional depthStencilState
           .setColorBlendState(Optional<VulkanPipelineColorBlendStateCreateInfo>) // optional colorBlendState
           .setDynamicState(Optional<VulkanPipelineDynamicStateCreateInfo>) // optional dynamicState
           .setLayout(com.io7m.jcoronado.api.VulkanPipelineLayoutType) // required layout
           .setRenderPass(Optional<com.io7m.jcoronado.api.VulkanRenderPassType>) // optional renderPass
           .setSubpass(int) // optional subpass
           .setBasePipeline(Optional<com.io7m.jcoronado.api.VulkanPipelineType>) // optional basePipeline
           .setBasePipelineIndex(OptionalInt) // optional basePipelineIndex
           .setRenderingCreateInfo(Optional<VulkanPipelineRenderingCreateInfo>) // optional renderingCreateInfo
           .build();

    Returns:
      A new VulkanGraphicsPipelineCreateInfo builder